
#include "config.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <badpenguin-fs.h>
#include "badpenguin-hardware.h"



int check_device_module(TPciDevice *devicepci ) {
  char tempstr[256];

  // avoid unknwon modules or problems
  if (devicepci->status < MODULE_STATUS_GENERIC ) return 0;
  if (devicepci->kernelModule == NULL ) return 0;

  // TODO: check lsmod first !!
    
  /* SCSI */
  if ( 0 == strcmp( devicepci->className, "SCSI") ) {
    strcpy(tempstr, DIR_PROC_SCSI );
    strcat(tempstr, "/");
    strcat(tempstr, devicepci->kernelModule );
    strcat(tempstr, "/0");
    if ( 0 == file_exists(tempstr) ) {
      devicepci->status = MODULE_STATUS_RUNNING;
      return 0;
    } else { 
      return -1;
    }
  }

  return 0;
}



int check_pci_devices(TChain *pcichain) {
  TChainItem *pciitem = NULL;
  pciitem = pcichain->head;
  while (pciitem!=NULL) {
    check_device_module(pciitem->data);
    pciitem = pciitem->next;
  }
  return 0;
}
