#include "config.h"
#include <assert.h>
#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include <unistd.h>

#include <badpenguin-ansi.h>
#include <badpenguin-chain.h>
#include <badpenguin-fs.h>
#include "badpenguin-hardware.h"

TBlockDevice *create_scsi_device() {
  return calloc(1, sizeof(TBlockDevice));
}


TChain *query_scsi_devices(TChain *devices) {
  TChainItem *pcurrent = NULL;
  TBlockDevice *pdata = NULL;
  FILE *fd = NULL;
  char sda[] = "/dev/sda";	// Count SCSI disks
  char scd[] = "/dev/scd0";	// Count SCSI cdroms
  char stp[] = "/dev/st0";	// Count SCSI tapes
  char *tempstr = NULL;
  char *tempdata = NULL;
  tempstr  = calloc( 256, sizeof(char) );
  tempdata = calloc( 256, sizeof(char) );

  // Clean Up previous Eide Chain
  if (devices!=NULL) {
    chain_cleanall(devices);
  } else {
    devices = chain_create();
  }

  // Controlla presenza SCSI
  if ( 0 != file_exists(DIR_PROC_SCSI) ) {
    printERROR("libhardware(SCS): directory %s inesistente !\n", DIR_PROC_SCSI );
    normal_color();
    return devices;
  }

  // Apre file SCSI
  fd = fopen(FILE_PROC_SCSI,"r");
  if (fd==NULL) {
    printERROR("libhardware(SCSI): impossibile aprire file %s\n", FILE_PROC_SCSI);
    normal_color();
    return devices;
  }

  // Cerca devices
  while (! feof(fd) ) {
    read_line(fd, tempstr);
    //printf(">%s\n", tempstr);
    
    // ... if vendore store it temporary
    if ( NULL != strstr(tempstr, "Vendor:")) {
      strncpy(tempdata, tempstr+10, 9);
      strncpy(tempdata+9, tempstr+26, 17 );
      tempdata[26]=0;
      //printf("VENDOR=%s\n", tempdata);
    } else
    if ( NULL != strstr(tempstr, "Type:")) {

      // Type checking: HARD DISKS
      if ( NULL != strstr(tempstr, MEDIA_DISK_SCSI)) {  
        //printf("Scsi dev =%s\n", sda);
	pcurrent = chain_append(devices);
	pcurrent->name   = strdup(sda);
	pcurrent->data   = create_scsi_device();
	pdata            = pcurrent->data;
        pdata->device    = strdup(pcurrent->name);
	pdata->model     = strdup(tempdata);
	pdata->media     = MEDIA_DISK_SCSI;
	//CHECK printf(" %-10s  %-30s  %-15s\n", current->name, current->model, "SCSI Disk" );
        //probe_cfdisk(first, current->name);
	// Increment scsi device name
	(sda[7])++;
        //printf("Scsi dev =%s\n", sda);
      } else
      // CHECK CDROMS
      if ( NULL != strstr(tempstr, MEDIA_CDROM_SCSI)) {  
        //printf("Scsi dev =%s\n", sda);
	pcurrent = chain_append(devices);
	pcurrent->name   = strdup(sda);
	pcurrent->data   = create_scsi_device();
	pdata            = pcurrent->data;
        pdata->device    = strdup(pcurrent->name);
	pdata->model     = strdup(tempdata);
	pdata->media     = MEDIA_CDROM_SCSI;
	//CHECK printf(" %-10s  %-30s  %-15s\n", current->name, current->model, "SCSI Disk" );
        //probe_cfdisk(first, current->name);
	// Increment scsi device name
	(scd[8])++;
        //printf("Scsi dev =%s\n", sda);
      } else
      // CHECK TAPES
      if ( NULL != strstr(tempstr, MEDIA_TAPE_SCSI)) {  
        //printf("Scsi dev =%s\n", sda);
	pcurrent = chain_append(devices);
	pcurrent->name   = strdup(stp);
	pcurrent->data   = create_scsi_device();
	pdata            = pcurrent->data;
        pdata->device    = strdup(pcurrent->name);
	pdata->model     = strdup(tempdata);
	pdata->media     = MEDIA_TAPE_SCSI;
	//CHECK printf(" %-10s  %-30s  %-15s\n", current->name, current->model, "SCSI Disk" );
        //probe_cfdisk(first, current->name);
	// Increment scsi device name
	(stp[7])++;
        //printf("Scsi dev =%s\n", sda);
      } 
      // end parsing devices
    }
  }
  fclose(fd);
  return devices;
}
